package net.phaedra.commons.utils;

import java.util.*;

import jin.collection.core.Criteria;
import jin.collection.core.Iter;
import jin.collection.util.PropertyUtil;

public class CollectionUtils {

   static public List asList(Object... elements) {
      ArrayList result = new ArrayList();
      result.addAll(Arrays.asList(elements));
      return result;
   }

   public static boolean exists(Collection collection, final String property, final Object expectedValue) {
      Collection matches = Iter.extract(collection, new Criteria() {
         public boolean match(Object element) {
            Object actualValue = PropertyUtil.getProperty(element, property);
            return expectedValue.equals(actualValue);
         }
      });
      return !matches.isEmpty();
   }

   // public static Set asSet(Object element) {
   // Set result = new HashSet();
   // result.add(element);
   // return result;
   // }
   //
   public static Set asSet(Object... elements) {
      Set result = new HashSet();
      for (int i = 0; i < elements.length; i++) {
         result.add(elements[i]);
      }
      return result;
   }

   public static Object firstOrNullFrom(List list) {
      return list.isEmpty() ? null : list.get(0);
   }

   static String[] stringArray(Collection collection) {
      return (String[]) collection.toArray(new String[collection.size()]);
   }

}
