package net.phaedra.commons.utils;

import java.io.File;
import java.io.IOException;
import java.util.*;

import jin.collection.core.*;

import org.apache.commons.io.FileUtils;

public class Folder {
   private final String directory;

   public Folder(String directory) {
      this.directory = directory;
   }

   public Folder(String directory, boolean forceCreation) throws IOException {
      this.directory = directory;
      if (forceCreation) {
         FileUtils.forceMkdir(new File(directory));
      }
   }

   public void deleteAll() {
      Collection visibleFiles = getListOfNotHiddenFiles();
      Iter.forEach(visibleFiles, new Operation() {
         public void execute(Object element) {
            File file = (File) element;
            file.delete();
            System.out.println("Cancellato file " + file);
         }
      });
   }

   public Collection getListOfNotHiddenFiles() {
      File file = new File(getDirectory());
      File[] filesToCollect = file.listFiles();
      ArrayList listOfFiles = new ArrayList(Arrays.asList(filesToCollect));

      Collection visibleFiles = Iter.extract(listOfFiles, new Criteria() {
         public boolean match(Object element) {
            File file = (File) element;
            return !file.isHidden();
         }
      });
      return visibleFiles;
   }

   public String getDirectory() {
      return directory;
   }
}