package net.phaedra.commons.utils;

import java.io.File;
import java.io.IOException;

import net.phaedra.commons.file.FileUtils;

public class ImageConverter {

   private final File sourceFile;
   private int width;
   private int height;
   private double percentage;
   private File targetFolder;

   public ImageConverter(final File file) {
      sourceFile = file;
      targetFolder = file.getParentFile();
   }

   public ImageConverter size(final int width, final int height) {
      this.width = width;
      this.height = height;
      return this;
   }

   public ImageConverter compression(final double percentage) {
      this.percentage = percentage;
      return this;
   }

   public String export() throws IOException {
      final String newFileName = FileUtils.fileNameWithNoExtension(sourceFile) + ".png";
      targetFolder.mkdir();
      final File target = new File(targetFolder, newFileName);
      new ProcessBuilder("convert", "-resize", width + "x" + height + "!", sourceFile.getAbsolutePath(), target
            .getAbsolutePath()).start();
      return newFileName;
   }

   public ImageConverter targetFolder(final File targetFolder) {
      this.targetFolder = targetFolder;
      return this;
   }
}
