package net.phaedra.commons.utils;

public class PerformanceTimer {

   private long lastPartial;
   private long start;
   private final String klass;

   public PerformanceTimer(Class klass) {
      this.klass = klass.getSimpleName();
   }

   public void start() {
      start = System.currentTimeMillis();
      lastPartial = start;
   }

   public void partial() {
      partial("");
   }

   public void partial(String msg) {
      long actualPartial = System.currentTimeMillis();
      print(msg, actualPartial, lastPartial);
      lastPartial = actualPartial;
   }

   private void print(String msg, long end, long begin) {
      System.out.println(klass + " - " + msg + ": " + (end - begin));
   }

   public void total() {
      long actualPartial = System.currentTimeMillis();
      print("total", actualPartial, start);
   }

}
