package net.phaedra.commons.utils;

public class StringSplitter {

   private final String original;

   public StringSplitter(String original) {
      this.original = original;
   }

   public String[] each(int numberOfChars) {
      int discard = original.length() % numberOfChars;
      if (discard != 0) {
         throw new IllegalArgumentException("number of characters must be a multiple of " + numberOfChars + " but is "
               + original.length());
      }
      int numberOfParts = original.length() / numberOfChars;
      String[] result = new String[numberOfParts];
      for (int i = 0; i < numberOfParts; i++) {
         int beginIndex = 0 + (numberOfChars * i);
         result[i] = original.substring(beginIndex, beginIndex + numberOfChars);
      }
      return result;
   }
}
