package net.phaedra.commons.utils;

public class Validations {

   public static void expectNotNull(Object value, String valueDescription) {
      if (value == null) {
         throw new IllegalArgumentException("Invalid null value for '" + valueDescription + "'");
      }
   }

   public static void expectEquals(int expected, int value, String valueDescription) {
      if (expected != value) {
         throw new IllegalArgumentException("Invalid " + valueDescription + " '" + value + "', expected '" + expected
               + "'");
      }
   }

   public static void expectEquals(Object expected, Object value, String valueDescription) {
      if (!expected.equals(value)) {
         throw new IllegalArgumentException("Invalid " + valueDescription + " '" + value + "', expected '" + expected
               + "'");
      }
   }

   public static boolean xNor(boolean hasIndirizzo, boolean hasProdotti) {
      return hasIndirizzo == hasProdotti;
   }

   public static boolean exists(String string) {
      return string != null && !"".equals(string);
   }

   public static void expectNotEquals(Object expected, Object value, String valueDescription) {
      if (expected == value) {
         throw new IllegalArgumentException("Invalid, " + valueDescription + ": actual: '" + value + "', expected: '"
               + expected + "'");
      }
   }

   public static void expectNot(boolean condition, String description) {
      if (condition) {
         throw new IllegalArgumentException("Invalid: '" + description);
      }
   }

   public static void expect(boolean condition, String description) {
      if (!condition) {
         throw new IllegalArgumentException("Invalid: '" + description);
      }
   }

   public static void expectNull(Object obj, String description) {
      expect(obj == null, "'" + description + "' was not null");
   }

   public static void expectElementsNotNull(Object... elements) {
      for (int i = 0; i < elements.length; i++) {
         expectNotNull(elements[i], elements[i].toString());
      }
   }

}
