package net.phaedra.commons.values;


public class Clock {

   private static Time fixedTime;

   public static Time now() {
      if (fixedTime == null) {
         fixedTime = new Time();
      }
      return fixedTime;
   }

   public static void stopTimeAt(Time time) {
      fixedTime = time;
   }

   public static Day today() {
      if (fixedTime != null) {
         return new Day(fixedTime.asDate());
      }
      return Day.today();
   }

   public static Ora ora() {
      Time now = now();
      return new Ora(now.getHours(), now.getMinutes());
   }

   public static void stopTimeAt(int hour, int minute) {
      stopTimeAt(new Time(1, 1, 1, hour, minute, 0));
   }

   public static void restart() {
      fixedTime = null;
   }

}
